<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>magpar: util/axesrot.c Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body>
<!-- Generated by Doxygen 1.6.3 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
  <div class="navpath"><a class="el" href="dir_81f17f03227d7067ce13f3651b0bf66b.html">util</a>
  </div>
</div>
<div class="contents">
<h1>axesrot.c</h1><a href="axesrot_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">    This file is part of magpar.</span>
<a name="l00003"></a>00003 <span class="comment"></span>
<a name="l00004"></a>00004 <span class="comment">    Copyright (C) 2002-2010 Werner Scholz</span>
<a name="l00005"></a>00005 <span class="comment"></span>
<a name="l00006"></a>00006 <span class="comment">    www:   http://www.magpar.net/</span>
<a name="l00007"></a>00007 <span class="comment">    email: magpar(at)magpar.net</span>
<a name="l00008"></a>00008 <span class="comment"></span>
<a name="l00009"></a>00009 <span class="comment">    magpar is free software; you can redistribute it and/or modify</span>
<a name="l00010"></a>00010 <span class="comment">    it under the terms of the GNU General Public License as published by</span>
<a name="l00011"></a>00011 <span class="comment">    the Free Software Foundation; either version 2 of the License, or</span>
<a name="l00012"></a>00012 <span class="comment">    (at your option) any later version.</span>
<a name="l00013"></a>00013 <span class="comment"></span>
<a name="l00014"></a>00014 <span class="comment">    magpar is distributed in the hope that it will be useful,</span>
<a name="l00015"></a>00015 <span class="comment">    but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00016"></a>00016 <span class="comment">    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00017"></a>00017 <span class="comment">    GNU General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">    You should have received a copy of the GNU General Public License</span>
<a name="l00020"></a>00020 <span class="comment">    along with magpar; if not, write to the Free Software</span>
<a name="l00021"></a>00021 <span class="comment">    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00022"></a>00022 <span class="comment">*/</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Id[] = <span class="stringliteral">&quot;$Id: axesrot.c 2962 2010-02-04 19:50:44Z scholz $\n\n&quot;</span>;
<a name="l00025"></a>00025 <span class="keyword">static</span> <span class="keywordtype">char</span> <span class="keyword">const</span> Td[] = <span class="stringliteral">&quot;$Today: &quot;</span> __FILE__ <span class="stringliteral">&quot;  &quot;</span> __DATE__ <span class="stringliteral">&quot;  &quot;</span>  __TIME__  <span class="stringliteral">&quot; $\n\n&quot;</span>;
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="util_8h.html">util.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;petscblaslapack.h&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a><a class="code" href="axesrot_8c.html#a5b63115a2dab7c63c692f4a4d739036c">00030</a> <span class="keywordtype">int</span> <a class="code" href="axesrot_8c.html#a5b63115a2dab7c63c692f4a4d739036c">checkortho</a>(PetscReal *axes1)
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032   PetscReal vec[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00033"></a>00033 
<a name="l00034"></a>00034   <span class="comment">/* check norm of column vectors */</span>
<a name="l00035"></a>00035   <span class="keywordflow">if</span> (
<a name="l00036"></a>00036     <a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,axes1,1)&lt;<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a> ||
<a name="l00037"></a>00037     <a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,axes1+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,1)&lt;<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a> ||
<a name="l00038"></a>00038     <a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,axes1+2*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,1)&lt;<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>
<a name="l00039"></a>00039   ) {
<a name="l00040"></a>00040       PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;rotation matrix is singular!\n&quot;</span>);
<a name="l00041"></a>00041       <span class="keywordflow">return</span>(0);
<a name="l00042"></a>00042   }
<a name="l00043"></a>00043 
<a name="l00044"></a>00044   <span class="comment">/* check that axes1 defines an orthogonal system */</span>
<a name="l00045"></a>00045   <span class="keywordflow">if</span> (
<a name="l00046"></a>00046     PetscAbsReal(<a class="code" href="griddata_8h.html#a021d4b2692fbdc52fc1fa201b4e17c99">my_ddot</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,axes1,1,axes1+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,1))&gt;<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a> ||
<a name="l00047"></a>00047     PetscAbsReal(<a class="code" href="griddata_8h.html#a021d4b2692fbdc52fc1fa201b4e17c99">my_ddot</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,axes1,1,axes1+2*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,1))&gt;<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a> ||
<a name="l00048"></a>00048     PetscAbsReal(<a class="code" href="griddata_8h.html#a021d4b2692fbdc52fc1fa201b4e17c99">my_ddot</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,axes1+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,1,axes1+2*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,1))&gt;<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>
<a name="l00049"></a>00049   ) {
<a name="l00050"></a>00050       PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;rotation matrix does not form an orthogonal system!\n&quot;</span>);
<a name="l00051"></a>00051       <span class="keywordflow">return</span>(0);
<a name="l00052"></a>00052   }
<a name="l00053"></a>00053 
<a name="l00054"></a>00054   <span class="comment">/* check handedness */</span>
<a name="l00055"></a>00055   <a class="code" href="griddata_8h.html#ae850fd05583e942377e4313b857e4adc">douter</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,axes1,axes1+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,vec);
<a name="l00056"></a>00056   <span class="keywordflow">if</span> (PetscAbsReal(<a class="code" href="griddata_8h.html#a021d4b2692fbdc52fc1fa201b4e17c99">my_ddot</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,axes1+2*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,1,vec,1))&lt;<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>) {
<a name="l00057"></a>00057     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;rotation matrix left-handed or singular!\n&quot;</span>);
<a name="l00058"></a>00058     <span class="keywordflow">return</span>(0);
<a name="l00059"></a>00059   }
<a name="l00060"></a>00060 
<a name="l00061"></a>00061   <span class="keywordflow">return</span>(1);
<a name="l00062"></a>00062 }
<a name="l00063"></a>00063 
<a name="l00064"></a><a class="code" href="util_8h.html#a55381bb85270f2885891ae5fcfa61369">00064</a> <span class="keywordtype">int</span> <a class="code" href="axesrot_8c.html#a55381bb85270f2885891ae5fcfa61369">AxesRotation</a>(PetscReal *slice_p,PetscReal *slice_n,PetscReal *axes1,<span class="keywordtype">int</span> inv,
<a name="l00065"></a>00065       <span class="keywordtype">int</span> n_vert,PetscReal *vertxyz,PetscReal *vertxyz2)
<a name="l00066"></a>00066 {
<a name="l00067"></a>00067   <a class="code" href="griddata_8h.html#a3d9da926137619fd02adb245a08536c7">MagparFunctionLogBegin</a>;
<a name="l00068"></a>00068 
<a name="l00069"></a>00069   <span class="comment">/* first, try to calculate rotation matrix based on slice_n */</span>
<a name="l00070"></a>00070   <span class="keywordflow">if</span> (slice_n!=PETSC_NULL &amp;&amp; <a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,slice_n,1)&gt;<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>) {
<a name="l00071"></a>00071 
<a name="l00072"></a>00072     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00073"></a>00073       <span class="stringliteral">&quot;perpendicular plane: %g*x+%g*y+%g*z=%g\n&quot;</span>,
<a name="l00074"></a>00074       slice_n[0],
<a name="l00075"></a>00075       slice_n[1],
<a name="l00076"></a>00076       slice_n[2],
<a name="l00077"></a>00077       <a class="code" href="griddata_8h.html#a021d4b2692fbdc52fc1fa201b4e17c99">my_ddot</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,slice_n,1,slice_p,1)
<a name="l00078"></a>00078     );
<a name="l00079"></a>00079 
<a name="l00080"></a>00080     PetscReal t_norm;
<a name="l00081"></a>00081     t_norm=1.0/<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,slice_n,1);
<a name="l00082"></a>00082     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00083"></a>00083       <span class="stringliteral">&quot;normalized normal: (%g,%g,%g)\n&quot;</span>,
<a name="l00084"></a>00084       slice_n[0]/t_norm,slice_n[1]/t_norm,slice_n[2]/t_norm
<a name="l00085"></a>00085     );
<a name="l00086"></a>00086 
<a name="l00087"></a>00087     <span class="comment">/* calculate cross product of y-axis with slice_n and store in axes1 */</span>
<a name="l00088"></a>00088     PetscReal axes3[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>]={1,0,0,0,1,0,0,0,1};
<a name="l00089"></a>00089     <a class="code" href="griddata_8h.html#ae850fd05583e942377e4313b857e4adc">douter</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,axes3+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*1,slice_n,axes1);
<a name="l00090"></a>00090     t_norm=<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,axes1,1);
<a name="l00091"></a>00091 
<a name="l00092"></a>00092     <span class="comment">/* if norm of axes1 does not vanish then renormalize */</span>
<a name="l00093"></a>00093     <span class="keywordflow">if</span> (t_norm &gt; 1000*<a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>) {
<a name="l00094"></a>00094       <a class="code" href="griddata_8h.html#acb0e2797b801a795093c32740f2c7256">my_dscal</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,1.0/t_norm,axes1,1);
<a name="l00095"></a>00095     }
<a name="l00096"></a>00096     <span class="keywordflow">else</span> {
<a name="l00097"></a>00097       <span class="comment">/* calculate cross product of x-axis with slice_n and store in axes1 */</span>
<a name="l00098"></a>00098       <a class="code" href="griddata_8h.html#ae850fd05583e942377e4313b857e4adc">douter</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,axes3,slice_n,axes1);
<a name="l00099"></a>00099 
<a name="l00100"></a>00100       <span class="comment">/* this time the norm must not vanish */</span>
<a name="l00101"></a>00101       t_norm=<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,axes1,1);
<a name="l00102"></a>00102       assert(t_norm &gt; <a class="code" href="griddata_8h.html#a26ab586dda1b8c780aa849e457c0cbad">D_EPS</a>);
<a name="l00103"></a>00103       <a class="code" href="griddata_8h.html#acb0e2797b801a795093c32740f2c7256">my_dscal</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,1.0/t_norm,axes1,1);
<a name="l00104"></a>00104     }
<a name="l00105"></a>00105 
<a name="l00106"></a>00106     <a class="code" href="griddata_8h.html#ae850fd05583e942377e4313b857e4adc">douter</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,slice_n,axes1,axes1+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*1);
<a name="l00107"></a>00107     t_norm=1.0/<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,axes1+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*1,1);
<a name="l00108"></a>00108     <a class="code" href="griddata_8h.html#acb0e2797b801a795093c32740f2c7256">my_dscal</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,t_norm,axes1+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*1,1);
<a name="l00109"></a>00109 
<a name="l00110"></a>00110     <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,slice_n,1,axes1+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*2,1);
<a name="l00111"></a>00111     t_norm=1.0/<a class="code" href="griddata_8h.html#ab47b959efcd0f78b2f58b0afbd532141">my_dnrm2</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,axes1+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*2,1);
<a name="l00112"></a>00112     <a class="code" href="griddata_8h.html#acb0e2797b801a795093c32740f2c7256">my_dscal</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,t_norm,axes1+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*2,1);
<a name="l00113"></a>00113 
<a name="l00114"></a>00114     <span class="comment">/* axes1 is now a set of three orthogonal axes</span>
<a name="l00115"></a>00115 <span class="comment">       where axes1+ND*2==slice_n</span>
<a name="l00116"></a>00116 <span class="comment">    */</span>
<a name="l00117"></a>00117   }
<a name="l00118"></a>00118 
<a name="l00119"></a>00119   <span class="comment">/* check rotation matrix */</span>
<a name="l00120"></a>00120   <span class="keywordflow">if</span> (!<a class="code" href="axesrot_8c.html#a5b63115a2dab7c63c692f4a4d739036c">checkortho</a>(axes1)) {
<a name="l00121"></a>00121 
<a name="l00122"></a>00122     <span class="comment">/* try to fix third vector */</span>
<a name="l00123"></a>00123     <a class="code" href="griddata_8h.html#ae850fd05583e942377e4313b857e4adc">douter</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,axes1,axes1+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,axes1+2*<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>);
<a name="l00124"></a>00124 
<a name="l00125"></a>00125     assert(<a class="code" href="axesrot_8c.html#a5b63115a2dab7c63c692f4a4d739036c">checkortho</a>(axes1));
<a name="l00126"></a>00126   }
<a name="l00127"></a>00127 
<a name="l00128"></a>00128   PetscPrintf(PETSC_COMM_WORLD,
<a name="l00129"></a>00129     <span class="stringliteral">&quot;rotation matrix:\n&quot;</span>
<a name="l00130"></a>00130     <span class="stringliteral">&quot;%10g %10g %10g\n&quot;</span>
<a name="l00131"></a>00131     <span class="stringliteral">&quot;%10g %10g %10g\n&quot;</span>
<a name="l00132"></a>00132     <span class="stringliteral">&quot;%10g %10g %10g\n&quot;</span>,
<a name="l00133"></a>00133     axes1[0],axes1[3],axes1[6],
<a name="l00134"></a>00134     axes1[1],axes1[4],axes1[7],
<a name="l00135"></a>00135     axes1[2],axes1[5],axes1[8]
<a name="l00136"></a>00136   );
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   <span class="comment">/* double check validity */</span>
<a name="l00139"></a>00139   assert(<a class="code" href="axesrot_8c.html#a5b63115a2dab7c63c692f4a4d739036c">checkortho</a>(axes1));
<a name="l00140"></a>00140 
<a name="l00141"></a>00141   <span class="comment">/* copy vertex coordinates into new array */</span>
<a name="l00142"></a>00142   ierr = PetscMemcpy(vertxyz2,vertxyz,<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*n_vert*<span class="keyword">sizeof</span>(PetscReal));CHKERRQ(ierr);
<a name="l00143"></a>00143 
<a name="l00144"></a>00144   <span class="keywordflow">if</span> (inv==0) {
<a name="l00145"></a>00145     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;applying normal rotation\n&quot;</span>);
<a name="l00146"></a>00146 
<a name="l00147"></a>00147     <span class="comment">/* translate the whole model to move the point into the origin */</span>
<a name="l00148"></a>00148     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;n_vert;i++) {
<a name="l00149"></a>00149       <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,-1.0,slice_p,1,vertxyz2+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i,1);
<a name="l00150"></a>00150     }
<a name="l00151"></a>00151     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00152"></a>00152       <span class="stringliteral">&quot;shifted by -(%g,%g,%g)\n&quot;</span>,
<a name="l00153"></a>00153       slice_p[0],slice_p[1],slice_p[2]
<a name="l00154"></a>00154     );
<a name="l00155"></a>00155 
<a name="l00156"></a>00156     <span class="comment">/* rotate vertxyz */</span>
<a name="l00157"></a>00157     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;n_vert;i++) {
<a name="l00158"></a>00158       PetscReal      DZero=0.0;
<a name="l00159"></a>00159       PetscReal      DOne=1.0;
<a name="l00160"></a>00160       <span class="keywordtype">int</span>            IOne=1;
<a name="l00161"></a>00161       <span class="keywordtype">int</span>            nd=<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00162"></a>00162       PetscReal      p[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 <span class="comment">/*</span>
<a name="l00165"></a>00165 <span class="comment">      cblas_dgemv(CblasColMajor,CblasTrans,ND,ND,1.0,axes1,ND,vertxyz2+ND*i,1,0.0,p,1);</span>
<a name="l00166"></a>00166 <span class="comment">*/</span>
<a name="l00167"></a>00167       BLASgemv_(<span class="stringliteral">&quot;T&quot;</span>,&amp;nd,&amp;nd,&amp;DOne,axes1,&amp;nd,vertxyz2+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i,&amp;IOne,&amp;DZero,p,&amp;IOne);
<a name="l00168"></a>00168       <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,p,1,vertxyz2+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i,1);
<a name="l00169"></a>00169     }
<a name="l00170"></a>00170   }
<a name="l00171"></a>00171   <span class="keywordflow">else</span> {
<a name="l00172"></a>00172     PetscPrintf(PETSC_COMM_WORLD,<span class="stringliteral">&quot;applying inverse rotation\n&quot;</span>);
<a name="l00173"></a>00173 
<a name="l00174"></a>00174     <span class="comment">/* rotate vertxyz */</span>
<a name="l00175"></a>00175     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;n_vert;i++) {
<a name="l00176"></a>00176       PetscReal      DZero=0.0;
<a name="l00177"></a>00177       PetscReal      DOne=1.0;
<a name="l00178"></a>00178       <span class="keywordtype">int</span>            IOne=1;
<a name="l00179"></a>00179       <span class="keywordtype">int</span>            nd=<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>;
<a name="l00180"></a>00180       PetscReal      p[<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>];
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 <span class="comment">/*</span>
<a name="l00183"></a>00183 <span class="comment">      cblas_dgemv(CblasColMajor,CblasTrans,ND,ND,1.0,axes1,ND,vertxyz2+ND*i,1,0.0,p,1);</span>
<a name="l00184"></a>00184 <span class="comment">*/</span>
<a name="l00185"></a>00185       BLASgemv_(<span class="stringliteral">&quot;N&quot;</span>,&amp;nd,&amp;nd,&amp;DOne,axes1,&amp;nd,vertxyz2+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i,&amp;IOne,&amp;DZero,p,&amp;IOne);
<a name="l00186"></a>00186       <a class="code" href="griddata_8h.html#aa89c56a68a27eb1d6913f275182ded8b">my_dcopy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,p,1,vertxyz2+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i,1);
<a name="l00187"></a>00187     }
<a name="l00188"></a>00188 
<a name="l00189"></a>00189     <span class="comment">/* translate the whole model */</span>
<a name="l00190"></a>00190     <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0;i&lt;n_vert;i++) {
<a name="l00191"></a>00191       <a class="code" href="griddata_8h.html#af02ecaab36e7afb38d59a0967b2a04c5">my_daxpy</a>(<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>,1.0,slice_p,1,vertxyz2+<a class="code" href="griddata_8h.html#a68d169e5b90cf721678bc7ab0f964a99">ND</a>*i,1);
<a name="l00192"></a>00192     }
<a name="l00193"></a>00193     PetscPrintf(PETSC_COMM_WORLD,
<a name="l00194"></a>00194       <span class="stringliteral">&quot;shifted by +(%g,%g,%g)\n&quot;</span>,
<a name="l00195"></a>00195       slice_p[0],slice_p[1],slice_p[2]
<a name="l00196"></a>00196     );
<a name="l00197"></a>00197   }
<a name="l00198"></a>00198 
<a name="l00199"></a>00199   <a class="code" href="griddata_8h.html#a8491466d8534a33d7163f5ea747e8210">MagparFunctionLogReturn</a>(0);
<a name="l00200"></a>00200 }
<a name="l00201"></a>00201 
</pre></div></div>
  <hr>
  <address>
    magpar - Parallel Finite Element Micromagnetics Package<br>
    Copyright (C) 2002-2010 Werner Scholz
  </address>
  </body>
</html>

